package org.eclipse.birt.test.appcontext;

import java.util.HashMap;

import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.HTMLRenderOption;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunAndRenderTask;
import org.eclipse.birt.report.engine.api.ReportEngine;


public class ExecuteReport {

	static void executeReport() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( "C:\\birt2m2\\eclipse\\plugins\\org.eclipse.birt.report.viewer_1.0.1\\birt" );	
		
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
		
		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign("C:\\work\\temp\\JavaPolis.rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		//retrieve report parameter values from ParameterDefinitionTask();
		IRunAndRenderTask task = engine.createRunAndRenderTask(design); 
		
		//Set Render context to handle url and image locataions
		HTMLRenderContext renderContext = new HTMLRenderContext();
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put( HTMLRenderContext.CONTEXT_NAME, renderContext );
		task.setContext( contextMap );
		
		//Set rendering options - such as file or stream output, 
		//output format, whether it is embeddable, etc
		HTMLRenderOption options = new HTMLRenderOption();
		options.setOutputFileName("c:\\work\\temp\\JavaPolis.html");
		options.setOutputFormat("html");
		task.setRenderOption(options);
		
		//run the report and destroy the engine
		task.run();
		engine.destroy();
	}	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			executeReport( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
